unit DayTexts;

interface

uses
   Variants,
   SyncObjs,
  nsRequest,  
  Windows, Classes, SysUtils, Forms,ClientDS, dateUtils;

//Date¥ ޸  True  False
function GetDayTextExists( Date: TDateTime ): Boolean;

//Date¥ ޸ Strings ־ش. ϸ True ش.
function GetDayText( Date: TDateTime; Strings: TStrings ): Boolean;

//Strings ִ  Date¥ Ѵ.
procedure SetDayText( Date: TDateTime; Strings: TStrings );
procedure SetDayTextLocal( acmd : string; dx: string; Strings: string );

//Date¥  Ѵ.
procedure DeleteDayText( Date: TDateTime );

//Ͱ Ǵ ..
function GetDBPath: String;

//Date¥ شϴ ϸ(ξ) Ѵ.
function GetDBName( Date: TDateTime ): String;

//Date¥ شϴ ü ϸ() Ѵ.
function GetDBFullName( Date: TDateTime ): String;

procedure GetMonthData(sr: TRequest; Date: TDateTime; AisGLobal: boolean; aForce: boolean = false);

var
  ds: TQueryMan;
  CurDate: Longword;
  Lock: TCriticalSection;
  UserName : string = '';
  isGLobal: boolean = false; //ü
  
implementation
uses Main_Frm;

function GetDBPath: String;
begin
  Result := ExtractFilePath( Application.ExeName );
end;

function GetDBName( Date: TDateTime ): String;
var
  Y, M, D: Word;
begin
  DecodeDate( Date, Y, M, D );
  Result := FormatFloat( '####0000', Y ) + FormatFloat( '##00', M ) + FormatFloat( '##00', D ) + '.txt';
end;

function GetDBFullName( Date: TDateTime ): String;
begin
  Result := GetDBPath + GetDBName( Date );
end;

function GetDayTextExists( Date: TDateTime ): Boolean;
var
  d: string;
begin
  d := FormatDateTime('yyyymmdd', date);
  Result := ds.Locate('DAYTEXT', d, []);
end;

function GetDayText( Date: TDateTime; Strings: TStrings ): Boolean;
var
  FileName: String;
  d: string;
begin
  d := FormatDateTime('yyyymmdd', date);
  Result := ds.Locate('DAYTEXT', d, []);
  if result then
   begin
     Strings.Text := ds.FieldByname('Memo').asString;
     Result := True;
   end;
end;

procedure SetDayTextLocal( acmd : string; dx: string; Strings: string );
var
  d: String;
begin
   Lock.Enter;


   try
   if Copy(dx,1,6) <> inttostr(CurDate) then exit;
   if acmd = 'D' then begin
       if ds.Locate('DAYTEXT', d, []) then begin
           ds.Delete;
       end;
   end else if aCmd = 'M' then begin

       d := dx;
      if not ds.Locate('DAYTEXT', d, []) then begin
        ds.Append;
        if not isGLobal then ds.FieldByname('USERNAME').AsString := UserName;
        ds.FieldByname('DAYMONTH').AsString := Copy(d,1,6);
        ds.FieldByname('DAYTEXT').AsString := d;
      end else ds.Edit;
      ds.FieldByname('MEMO').AsString := strings;

      ds.Post;

  end;

  finally
        ds.ApplyLocalUpdates;

        Main_Form.Calendar.Update;
        //Invalidate;

       Lock.Leave;
  end;
end;


procedure SetDayText( Date: TDateTime; Strings: TStrings );
var
  d: String;
  aIns: boolean;
begin
   Lock.Enter;
   try
  d := FormatDateTime('yyyymmdd', date);
  aIns := false;
  if not ds.Locate('DAYTEXT', d, []) then begin
    aIns := true;
    ds.Append;
    if not isGLobal then ds.FieldByname('USERNAME').AsString := UserName;
    ds.FieldByname('DAYMONTH').AsString := FormatDateTime('yyyymm', date);
    ds.FieldByname('DAYTEXT').AsString := d;
  end else ds.Edit;

  ds.FieldByname('MEMO').AsString := Strings.Text;
  ds.Post;
  ds.ApplyUpdates;


  if aIns then begin
    ds.Close;
    ds.Open;
  end;
  if isGlobal then begin
    TRequest(ds.Request).SendMsgNoResult('CHANGE', FormatDateTime('yyyymm', date));
  end;
  finally
       Lock.Leave;
  end;
end;

procedure DeleteDayText( Date: TDateTime );
var
  d: String;
begin
  Lock.Enter;
  try
  d := FormatDateTime('yyyymmdd', date);
  if ds.Locate('DAYTEXT', d, []) then begin
      ds.Delete;
      ds.ApplyUpdates;
  end;
  finally
       Lock.Leave;
  end;

end;


procedure GetMonthData(sr: TRequest; Date: TDateTime; aisGlobal: boolean; aForce: boolean);
var
  d: string;
begin
  d := FormatDateTime('yyyymm', date);
  if (aForce) or (aisGlobal <> isGLobal) or (StrToInt(d) <> CurDate)  then begin
      isGlobal := aisGlobal; 
       ds.Close;
       ds.Params.Clear;
       if isGlobal then begin
          ds.SQL.Text := 'select * from daydata where DAYMONTH = :XDATE AND USERNAME IS NULL';
       end else begin
          ds.SQL.Text := 'select * from daydata where DAYMONTH = :XDATE AND USERNAME = :XUSERNAME';
          ds.AddParams('XUSERNAME', USERNAME);
       end;
       ds.AddParams('XDATE', FormatDateTime('yyyymm', Date));
       ds.Request := sr;
       ds.Open;
       CurDate := StrToInt(d);
  end;
end;

initialization

  ds := TQueryMan.Create(nil);
  ds.ReadOnlyFields.text := 'ID';
  ds.tableName := 'DayData';
  ds.KeyField := 'ID';
  
  CurDate := 0;
  Lock := TCriticalSection.Create;
finalization
  ds.Free;
  Lock.Free;
end.
