unit uMain;

interface

uses nsUserbase, nsParams,
  uUserList,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBTables, DB, NsSessionPool, NsCustomDataProvider,
  NsDataProvider, NsBDEDataProvider, NetServerBase, NetServerDelphi, NSBase,
  StdCtrls;

type
  TForm1 = class(TForm)
    Session1: TSession;
    ns: TNetServer;
    NetServerDelphi1: TNetServerDelphi;
    NsBDEDataProvider1: TNsBDEDataProvider;
    NsSessionPool1: TNsSessionPool;
    btnStart: TButton;
    btnStop: TButton;
    btnUser: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure nsUserLogin(Sender: TObject; aUser: TnsUser; aUserName,
      aPassword: String; aClientParams, AParams: TnsParams; var aUseDB,
      aAccept: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure btnUserClick(Sender: TObject);
    procedure nsDisconnect(Sender, aUser: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    UserList : TStrings;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  UserList := TStringList.Create;
  if FileExists('userlist.txt') then Userlist.LoadFromFile('userlist.txt');
  Session1.DeleteAlias('BKCAL');
  Session1.addStandardAlias('BKCAL', ExtractFilepath(Application.ExeName), 'PARADOX');
end;

procedure TForm1.btnStartClick(Sender: TObject);
begin
  if Userlist.COunt = 0 then raise Exception.Create('There is no user who can connect. Please add user first');
  if not ns.Active then
  ns.Open;
  btnUser.Enabled := not ns.Active;
  btnStart.Enabled := not ns.Active;
  btnStop.Enabled := ns.Active;
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  if ns.Active then
  ns.Close;
  btnUser.Enabled := not ns.Active;
  btnStart.Enabled := not ns.Active;
  btnStop.Enabled := ns.Active;
end;

procedure TForm1.nsUserLogin(Sender: TObject; aUser: TnsUser; aUserName,
  aPassword: String; aClientParams, AParams: TnsParams; var aUseDB,
  aAccept: Boolean);
begin
  aAccept := (aUserName <> '') and (Userlist.Values[auserName] = aPassword);
  if aAccept then begin
    ns.FIndAndDisconnect(aUserName); //Disconnect prior same username
    ns.BroadcastMsg('LOGIN', aUserName); //Let other people know user login
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Userlist.SaveToFile('userlist.txt');
  UserList.Free;
end;

procedure TForm1.btnUserClick(Sender: TObject);
begin
  frmUserlist := TfrmuserList.Create(nil);
  frmUserList.Load(Userlist);
  frmuserList.SHowModal;
  frmUserlist.Free;
end;

procedure TForm1.nsDisconnect(Sender, aUser: TObject);
begin
  ns.BroadcastMsg('LOGOUT', TnsUser(aUser).User.Username); //Let other people know user logout
end;

end.
